Assocation aborted due to network timeout in storescp
2014-12-10 17:27 - Jorg Riesmeier
Description

According to the following forum posting, the receive timeout in the network module can cause problems when it takes too long to
send the data, e.g. when the SCU needs to convert huge amounts of pixel data based on the negotiated transfer syntax:

http:/forum.dcmtk.org/viewtopic.php?f=1&t=4140

In the above forum posting, the author also asks whether the error code DUL_PEERABORTEDASSOCIATION really is appropriate.
He proposes DUL_NETWORKCLOSED (or something like that).

Of course, the timeout value (60 seconds) should be configurable too.

Related issues:
Related to DCMTK - Bug #524: recv() timeout parameter should be configurable ... Closed 2013-06-14

History

#1 - 2015-04-08 13:34 - Jorg Riesmeier
- File socket_timeout_patch_2.diff added

The attached patch has been provided by "Ryan, William J. (Bill)" <ryan.william@mayo.edu> (see his email from 2015-04-01):

We recently ran into a particular device that was keeping an association alive while acquiring more images. Often, the delay between images
would last longer than 60 seconds, and the underlying socket would timeout and hang up. | found a post on your forums regarding the
DISABLE_SEND_TIMEOUT pre-processor definition which lead me to the right place in the code to solve my problem. Rather than just
compiling with this option turned on, we needed a little more control on the duration of the socket’s timeout. So | added some code to allow the
user to pass in an explicit value on the command line. | thought this feature may be useful for others that experience the same problem.

I've created a patch and attached it here. | really must apologize in advance since | don’t know all of your best practices and coding standards. |
just sent a solution that worked for us, and imagine you'll be able to adapt the code to your standards.

If you need me to take any other steps — such as posting a note to your forum or creating a feature request in some system — please let me know
and I'll do my best to get what you need.

#2 - 2017-01-19 14:27 - J6rg Riesmeier

- Assignee set to Jérg Riesmeier

#3 - 2017-01-19 17:08 - Jorg Riesmeier
- Status changed from New to Assigned

- % Done changed from 0 to 80

With commit 8d73a7f, the send() and recv() timeouts are now configurable at runtime (default is still 60 seconds).
What's still missing is to check whether the error code DUL_PEERABORTEDASSOCIATION is appropriate (see above).
#4 - 2017-02-24 17:20 - JO6rg Riesmeier

Further investigations (with "storescp -ts 1" and "dcmsend +dly" trying to send a very large compressed DICOM image that needs to be
decompressed for transfer) show...
When the receive timeout elapsed on storescp-side, the output to the logger is:

DIMSE receiveCommand

DUL FSM Table: State: 6 Event: 16

DUL Event: Transport connection closed
DUL Action: AA 4 Indicate AP Abort
Association Aborted

HoHH A

On client-side (e.g. dcmsend), the output is:

cannot send SOP instance: DIMSE Failed to send message

Aborting Association

e I e B B i

#5 - 2017-02-24 18:11 - Jorg Riesmeier

Failed sending C-STORE request: 0006:020e DIMSE Failed to
0006:031d TCP I/0 Error (Broken pipe) occurred in routine:

0006:031d TCP I/0 Error (Broken pipe) occurred in routine:

Association Abort Failed: 0006:031d TCP I/O Error (Broken

send message
writeDataPDU

writeDataPDU

pipe) occurred in routine:

sendAbortTCP

After checking the DICOM standard (state machine in Part 8), the implemented state transition (see above) seems to be correct. However, I'm not
sure whether the returned DUL_PEERABORTEDASSOCIATION is really appropriate:

/* AA_4_IndicateAPAbort

* *

** Purpose:

B3 e Issue A-P-ABORT indication primitive.

* %

** Parameter Dictionary:
* *

W network Handle to the network environment

*x association Handle to the Association

i nextState The next state to be reached from the current state
W params Service parameters describing the Association

* %

** Return Values:
** Notes:
* %

** Algorithm:

W Description of the algorithm (optional) and any other notes.

*/

static OFCondition
AA_4_IndicateAPAbort (PRIVATE_NETWORKKEY ** /*network*/,

PRIVATE_ASSOCIATIONKEY ** association, int nextState, void * /*params*/)

closeTransport (association);
(*association)->protocolState = nextState;
return DUL_PEERABORTEDASSOCIATION;

There does not seem to be a condition constant for A-P-ABORT... the same condition constant is returned by AA_3_IndicatePeerAborted().

#6 - 2017-03-24 12:49 - Marco Eichelberg
- Target version changed from 3.6.2 to 3.6.3

#7 - 2017-12-07 11:51 - Marco Eichelberg
- Target version changed from 3.6.3 to 3.6.6

#8 - 2020-05-25 13:28 - Michael Onken
- Target version deleted (3.6.6)
